<template>
  <div class="hello">
    {{str}}
  </div>
</template>

<script>
export default {
  name: 'Child1',
  props: {
    str: String,
    type: {
　    // 自定义验证函数
      validator: (value) => {
        return ['success', 'warning', 'danger'].includes(value)
      }
    },
    onChange: {
      //对于接收的数据，可以是各种数据类型，同样也可以传递一个函数
      type: Function,
      default: () => { }
    },
    isVisible: {
      type: Boolean,
      default: false
    },
    arr: {
      type: Array,
      // 对象或数组默认值必须从一个工厂函数获取
      default: () => []
    }
    
  },
  data () {
    return {
      msg: 'Child1'
    }
  },
  created () {
    console.log(this.str);
    console.log(this.arr);
    console.log(this.isVisible);
    console.log(this.type);
    // 子组件调用父组件的函数
    this.onChange();
    // 调用父组件传过的属性
    console.log(this.$attrs);
  },
  mounted(){
    // 获取父组件传过设置的样式
    console.log(this.$el.style);
    console.log(this.$el.className);
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>

</style>
